/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.ldt.fee.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.apache.commons.lang3.StringUtils;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.ldt.mall.entity.Mall;
import org.springblade.ldt.mall.service.IMallService;
import org.springblade.ldt.shop.entity.Shop;
import org.springblade.ldt.shop.service.IShopService;
import org.springframework.util.Assert;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.ldt.fee.entity.ProductFee;
import org.springblade.ldt.fee.vo.ProductFeeVO;
import org.springblade.ldt.fee.wrapper.ProductFeeWrapper;
import org.springblade.ldt.fee.service.IProductFeeService;
import org.springblade.core.boot.ctrl.BladeController;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-10-18
 */
@RestController
@AllArgsConstructor
@RequestMapping("ldt_product_fee/productfee")
@Api(value = "", tags = "接口")
public class ProductFeeController extends BladeController {

	private final IProductFeeService productFeeService;

	private final IMallService mallService;

	private final IShopService shopService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入productFee")
	public R<ProductFeeVO> detail(ProductFee productFee) {
		ProductFee detail = productFeeService.getOne(Condition.getQueryWrapper(productFee));
		return R.data(ProductFeeWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入productFee")
	public R<IPage<ProductFeeVO>> list(String shopId,String mallId,ProductFee productFee, Query query) {
		if(StringUtils.isNotEmpty(mallId)){
			Mall mall = mallService.getById(mallId);
			Assert.notNull(mall,"找不到该商场信息");
			productFee.setMerchantNo(mall.getMerchantNo());
		}else if (StringUtils.isNotEmpty(shopId)){
			Shop shop = shopService.getById(shopId);
			Assert.notNull(shop,"找不到该商户信息");
			productFee.setMerchantNo(shop.getMerchantNo());
		}else{
			return R.fail("商场id或商户id至少一个不能为空");
		}
		IPage<ProductFee> pages = productFeeService.page(Condition.getPage(query), Condition.getQueryWrapper(productFee).lambda().orderByDesc(ProductFee::getCreateTime));
		return R.data(ProductFeeWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入productFee")
	public R<IPage<ProductFeeVO>> page(ProductFeeVO productFee, Query query) {
		IPage<ProductFeeVO> pages = productFeeService.selectProductFeePage(Condition.getPage(query), productFee);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入productFee")
	public R save(@Valid @RequestBody ProductFee productFee) {
		return R.status(productFeeService.save(productFee));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入productFee")
	public R update(@Valid @RequestBody ProductFee productFee) {
		return R.status(productFeeService.updateById(productFee));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入productFee")
	public R submit(@Valid @RequestBody ProductFee productFee) {
		return R.status(productFeeService.saveOrUpdate(productFee));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(productFeeService.deleteLogic(Func.toLongList(ids)));
	}


}
